Package org.apache.commons.collections4

# Interface SortedBidiMap<K,V>

Type Parameters:
  `K` - the type of the keys in the map
  `V` - the type of the values in the map

All Superinterfaces:
  `BidiMap<K,V>`, `Get<K,V>`, `IterableGet<K,V>`, `IterableMap<K,V>`, `Map<K,V>`, `OrderedBidiMap<K,V>`, `OrderedMap<K,V>`, `Put<K,V>`, `SortedMap<K,V>`

All Known Implementing Classes:
  `AbstractSortedBidiMapDecorator`, `DualTreeBidiMap`, `UnmodifiableSortedBidiMap`

public interface SortedBidiMap<K,V> extends OrderedBidiMap<K,V>, SortedMap<K,V>
Defines a map that allows bidirectional lookup between key and values and retains both keys and values in sorted order.

Implementations should allow a value to be looked up from a key and a key to be looked up from a value with equal performance.

Since:
  3.0

- ## Nested Class Summary

  ## Nested classes/interfaces inherited from interface java.util.Map

  `Map.Entry<K extends Object,V extends Object>`

- ## Method Summary

  Modifier and Type
  Method
  Description
  `SortedBidiMap<V,K>`
  `inverseBidiMap()`
  Gets a view of this map where the keys and values are reversed.
  `Comparator<? super V>`
  `valueComparator()`
  Gets the comparator used for the values in the value-to-key map aspect.

  ### Methods inherited from interface org.apache.commons.collections4.BidiMap

  `getKey, put, removeValue, values`

  ### Methods inherited from interface org.apache.commons.collections4.Get

  `containsKey, containsValue, entrySet, get, isEmpty, keySet, remove, size, values`

  ### Methods inherited from interface java.util.Map

  `clear, compute, computeIfAbsent, computeIfPresent, containsKey, containsValue, equals, forEach, get, getOrDefault, hashCode, isEmpty, merge, putAll, putIfAbsent, remove, remove, replace, replace, replaceAll, size`

  ### Methods inherited from interface org.apache.commons.collections4.OrderedMap

  `firstKey, lastKey, mapIterator, nextKey, previousKey`

  ### Methods inherited from interface org.apache.commons.collections4.Put

  `clear, put, putAll`

  ### Methods inherited from interface java.util.SortedMap

  `comparator, entrySet, firstKey, headMap, keySet, lastKey, subMap, tailMap, values`

- ## Method Details

  - ### inverseBidiMap

    SortedBidiMap<V,K> inverseBidiMap()
    Gets a view of this map where the keys and values are reversed.

    Changes to one map will be visible in the other and vice versa. This enables both directions of the map to be accessed equally.

    Implementations should seek to avoid creating a new object every time this method is called. See `AbstractMap.values()` etc. Calling this method on the inverse map should return the original.

    Implementations must return a `SortedBidiMap` instance, usually by forwarding to `inverseSortedBidiMap()`.

    Specified by:
      `inverseBidiMap` in interface `BidiMap<K,V>`
    Specified by:
      `inverseBidiMap` in interface `OrderedBidiMap<K,V>`
    Returns:
      an inverted bidirectional map

  - ### valueComparator

    Comparator<? super V> valueComparator()
    Gets the comparator used for the values in the value-to-key map aspect.
    Returns:
      Comparator<? super V>